Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netapp/dbg_cons.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -37,4 +37,5 @@
 
 #include <stdlib.h>
+#include <string.h>
 
 #ifdef TARGET_KERNEL_ASP
@@ -44,7 +45,8 @@
 #include <syssvc/serial.h>
 #include <syssvc/logtask.h>
-#include "kernel_cfg.h"
 #include "kernel/kernel_impl.h"
 #include "kernel/task.h"
+#include "kernel_cfg.h"
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -55,4 +57,5 @@
 #include <t_services.h>
 #include "kernel_id.h"
+#include "tinet_id.h"
 
 #include "../kernel/jsp_kernel.h"
@@ -69,4 +72,5 @@
 #include <net/ethernet.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_timer.h>
@@ -83,36 +87,38 @@
 #include <netinet/ip.h>
 #include <netinet/ip_var.h>
-#include <netinet/ip6.h>
-#include <netinet6/ip6_var.h>
-#include <netinet6/nd6.h>
 #include <netinet/if_ether.h>
 #include <netinet/tcp.h>
-#include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
 #include <netinet/tcp_fsm.h>
+#include <netinet/tcp_timer.h>
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
 
+#include <netinet6/nd6.h>
+
 #include <net/if_var.h>
-#include <net/if6_var.h>
 
 #include <netapp/netapp.h>
 #include <netapp/netapp_var.h>
-#include <netapp/echo.h>
-#include <netapp/discard.h>
+#include <netapp/wwws.h>
+#include <netapp/tcp_echo_srv1.h>
+#include <netapp/tcp_echo_srv2.h>
+#include <netapp/tcp_echo_cli.h>
+#include <netapp/tcp_discard_cli.h>
+#include <netapp/udp6_echo_srv.h>
+#include <netapp/udp4_echo_srv.h>
+#include <netapp/udp6_echo_cli.h>
+#include <netapp/udp4_echo_cli.h>
+#include <netapp/udp_discard_cli.h>
+#include <netapp/resolver.h>
 #include <netapp/dbg_cons.h>
-
-#ifdef USE_LCD
-
-#include "sc1602/lcd.h"
-
-#endif	/* of #ifdef USE_LCD */
+#include <netapp/dhcp6_cli.h>
+#include <netapp/dhcp4_cli.h>
+#include "lcd.h"
 
 #ifdef USE_DBG_CONS
 
-#define DBG_LINE_SIZE	63
-
 /*
- *  task_status -- タスクの状態の出力
+ *  dbg_cons_task_status -- タスクの状態の出力
  */
 
@@ -127,6 +133,6 @@
 	};
 
-static void
-task_status (ID portid, char *line)
+void
+dbg_cons_task_status (ID portid, char *line)
 {
 	TCB	*tcb;
@@ -149,5 +155,5 @@
 			st >>= 1;
 			}
-		cons_printf(portid, "\n");
+		cons_putchar(portid, '\n');
 		}
 
@@ -176,8 +182,138 @@
 	};
 
+#if defined(SUPPORT_INET6)
+
+static void
+tcp_cep_status (ID portid, char *line)
+{
+	T_TCP_CEP*	cep;
+	int		len;
+
+#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0
+
+	T_TCP_TWCEP*	twcep;
+
+#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
+
+	cons_printf(portid,
+	            "TCP CEP Status\n"
+	            "ID  Snd-Q Rcv-Q Foreign Address                               State\n");
+
+	for (cep = tcp_cep; cep < &tcp_cep[tmax_tcp_cepid]; cep ++)
+		if (!VALID_TCP_CEP(cep)) {
+			cons_printf(portid,
+			            "%2d%c%c     0     0"
+			            " -                                            "
+			            " INVALID\n",
+			            GET_TCP_CEPID(cep),
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
+			}
+		else if (cep->fsm_state == TCP_FSM_CLOSED) {
+			cons_printf(portid,
+			            "%2d%c%c     0     0"
+			            " -                                            "
+			            " CLOSED\n",
+			            GET_TCP_CEPID(cep),
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
+			}
+		else if (cep->fsm_state == TCP_FSM_LISTEN) {
+			cons_printf(portid,
+			            "%2d%c%c     0     0"
+			            " -                                            "
+			            " LISTEN\n",
+			            GET_TCP_CEPID(cep),
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
+			}
+		else {
+			cons_printf(portid,
+			            "%2d%c%c %5d %5d ",
+			            GET_TCP_CEPID(cep),
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4',
+			            cep->swbuf_count, cep->rwbuf_count);
+
 #if defined(SUPPORT_INET4)
 
+			if (TCP_IS_CEP_IPV4(cep)) {
+				T_IN4_ADDR	addr;
+
+				addr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+				len  = put_ipv4addr(portid, &addr, 0);
+				}
+			else
+				len  = put_ipv6addr(portid, &cep->dstaddr.ipaddr, 0);
+
+#else	/* of #if defined(SUPPORT_INET4) */
+
+			len  = put_ipv6addr(portid, &cep->dstaddr.ipaddr, 0);
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+			cons_putchar(portid, '.');
+			len += cons_putnumber(portid, cep->dstaddr.portno, 10, radhex, 0, false, ' ');
+			for (len = 44 - len; len -- > 0; )
+				cons_putchar(portid, ' ');
+			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
+				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
+				                    cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
+			else
+				cons_printf(portid, " %s\n", tcp_fsm_str[cep->fsm_state]);
+			}
+
+#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0
+
+	for (twcep = tcp_twcep; twcep < &tcp_twcep[NUM_TCP_TW_CEP_ENTRY]; twcep ++) {
+		if (twcep->fsm_state == TCP_FSM_CLOSED) {
+			cons_printf(portid,
+			            "%2dTW     0     0"
+			            " -                                            "
+			            " CLOSED\n",
+			            GET_TCP_TWCEPID(twcep));
+			}
+		else {
+			cons_printf(portid, "%2dTW     0     0 ", GET_TCP_TWCEPID(twcep));
+
+#if defined(SUPPORT_INET4)
+
+			if (TCP_IS_CEP_IPV4(twcep)) {
+				T_IN4_ADDR	addr;
+
+				addr = ntohl(twcep->dstaddr.ipaddr.s6_addr32[3]);
+				len  = put_ipv4addr(portid, &addr, 0);
+				}
+			else
+				len  = put_ipv6addr(portid, &twcep->dstaddr.ipaddr, 0);
+
+#else	/* of #if defined(SUPPORT_INET4) */
+
+			len  = put_ipv6addr(portid, &twcep->dstaddr.ipaddr, 0);
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+			cons_putchar(portid, '.');
+			len += cons_putnumber(portid, twcep->dstaddr.portno, 10, radhex, 0, false, ' ');
+			for (len = 44 - len; len -- > 0; )
+				cons_putchar(portid, ' ');
+			if (twcep->fsm_state == TCP_FSM_TIME_WAIT)
+				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[twcep->fsm_state],
+				                    twcep->timer_2msl / TCP_SLOW_HZ);
+			else
+				cons_printf(portid, " %s\n", tcp_fsm_str[twcep->fsm_state]);
+			}
+		}
+
+#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
+
+	}
+
+#else	/* of #if defined(SUPPORT_INET6) */
+
+#if defined(SUPPORT_INET4)
+
 static void
-tcp_status (ID portid, char *line)
+tcp_cep_status (ID portid, char *line)
 {
 	T_TCP_CEP*	cep;
@@ -190,12 +326,4 @@
 #endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
 
-#ifdef TCP_CFG_PASSIVE_OPEN
-
-	T_TCP_REP*	rep;
-	int_t		cnt;
-
-#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */
-
-	WAI_NET_CONS_PRINTF();
 	cons_printf(portid,
 	            "TCP CEP Status\n"
@@ -205,25 +333,28 @@
 		if (!VALID_TCP_CEP(cep)) {
 			cons_printf(portid,
-			            "%2d%c     0     0"
+			            "%2d%c%c     0     0"
 			            " -                    "
 			            " -                    "
 			            " INVALID\n",
 			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
 			}
 		else if (cep->fsm_state == TCP_FSM_CLOSED) {
 			cons_printf(portid,
-			            "%2d%c     0     0"
+			            "%2d%c%c     0     0"
 			            " -                    "
 			            " -                    "
 			            " CLOSED\n",
 			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
 			}
 		else if (cep->fsm_state == TCP_FSM_LISTEN) {
 			cons_printf(portid,
-			            "%2d%c     0     0 ",
+			            "%2d%c%c     0     0 ",
 			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
+			            DYNAMIC_TCP_CEP(cep) ? 'D' : '.',
+			            TCP_IS_CEP_IPV6(cep) ? '6' : '4');
 			len  = PUT_IPADDR(portid, &cep->myaddr.ipaddr, 0);
 			cons_putchar(portid, ':');
@@ -263,5 +394,5 @@
 		if (twcep->fsm_state == TCP_FSM_CLOSED) {
 			cons_printf(portid,
-			            "%2dTW    0     0"
+			            "%2dTW     0     0"
 			            " -                    "
 			            " -                    "
@@ -270,5 +401,5 @@
 			}
 		else {
-			cons_printf(portid, "%2dTW    0     0 ", GET_TCP_TWCEPID(twcep));
+			cons_printf(portid, "%2dTW     0     0 ", GET_TCP_TWCEPID(twcep));
 			len  = PUT_IPADDR(portid, &twcep->myaddr.ipaddr, 0);
 			cons_putchar(portid, ':');
@@ -291,144 +422,27 @@
 #endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
 
-#ifdef TCP_CFG_PASSIVE_OPEN
+	}
+
+#endif	/* of #if defined(SUPPORT_INET4) */
+
+#endif	/* of #if defined(SUPPORT_INET6) */
+
+#if TNUM_TCP6_REPID > 0
+
+static void
+tcp6_rep_status (ID portid, char *line)
+{
+	T_TCP_CEP*	cep;
+	T_TCP6_REP*	rep;
+	ID		repid;
+	int_t		cnt;
+	uint_t		len;
 
 	cons_printf(portid,
-	            "TCP REP Status\n"
+	            "TCP6 REP Status\n"
 	            "ID  Local Address         CEP\n");
-	for (rep = tcp_rep; rep < &tcp_rep[tmax_tcp_repid]; rep ++) {
-		cons_printf(portid, "%2d%c ", GET_TCP_REPID(rep), DYNAMIC_TCP_REP(rep) ? 'D' : ' ');
-		if (VALID_TCP_REP(rep)) {
-			len  = PUT_IPADDR(portid, &rep->myaddr.ipaddr, 0);
-			cons_putchar(portid, ':');
-			len += cons_putnumber(portid, rep->myaddr.portno, 10, radhex, 0, false, ' ');
-			for (len = 21 - len; len -- > 0; )
-				cons_putchar(portid, ' ');
-			cnt = 0;
-			for (cep = tcp_cep; cep < &tcp_cep[tmax_tcp_cepid]; cep ++) {
-				if (cep->rep == rep) {
-					if (cnt > 0)
-						cons_printf(portid, ",%d", GET_TCP_CEPID(cep));
-					else
-						cons_printf(portid, "%d", GET_TCP_CEPID(cep));
-					cnt ++;
-					}
-				}
-			}
-		else
-			cons_printf(portid, "INVALID");
-		cons_putchar(portid, '\n');
-		}
-
-#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */
-
-	SIG_NET_CONS_PRINTF();
-	FLUSH_SND_BUFF();
-	}
-
-#endif	/* of #if defined(SUPPORT_INET4) */
-
-#if defined(SUPPORT_INET6)
-
-static void
-tcp_status (ID portid, char *line)
-{
-	T_TCP_CEP*	cep;
-	uint_t		len;
-
-#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0
-
-	T_TCP_TWCEP*	twcep;
-
-#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
-
-#ifdef TCP_CFG_PASSIVE_OPEN
-
-	T_TCP_REP*	rep;
-	int_t		cnt;
-
-#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */
-
-	WAI_NET_CONS_PRINTF();
-	cons_printf(portid,
-	            "TCP CEP Status\n"
-	            "ID  Snd-Q Rcv-Q Foreign Address                             State\n");
-
-	for (cep = tcp_cep; cep < &tcp_cep[tmax_tcp_cepid]; cep ++)
-		if (!VALID_TCP_CEP(cep)) {
-			cons_printf(portid,
-			            "%2d%c     0     0"
-			            " -                                          "
-			            " INVALID\n",
-			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
-			}
-		else if (cep->fsm_state == TCP_FSM_CLOSED) {
-			cons_printf(portid,
-			            "%2d%c     0     0"
-			            " -                                          "
-			            " CLOSED\n",
-			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
-			}
-		else if (cep->fsm_state == TCP_FSM_LISTEN) {
-			cons_printf(portid,
-			            "%2d%c     0     0"
-			            " -                                          "
-			            " LISTEN\n",
-			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ');
-			}
-		else {
-			cons_printf(portid,
-			            "%2d%c %5d %5d ",
-			            GET_TCP_CEPID(cep),
-			            DYNAMIC_TCP_CEP(cep) ? 'D' : ' ',
-			            cep->swbuf_count, cep->rwbuf_count);
-			len  = PUT_IPADDR(portid, &cep->dstaddr.ipaddr, 0);
-			cons_putchar(portid, '.');
-			len += cons_putnumber(portid, cep->dstaddr.portno, 10, radhex, 0, false, ' ');
-			for (len = 42 - len; len -- > 0; )
-				cons_putchar(portid, ' ');
-			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
-				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
-				                    cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
-			else
-				cons_printf(portid, " %s\n", tcp_fsm_str[cep->fsm_state]);
-			}
-
-#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0
-
-	for (twcep = tcp_twcep; twcep < &tcp_twcep[NUM_TCP_TW_CEP_ENTRY]; twcep ++) {
-		if (twcep->fsm_state == TCP_FSM_CLOSED) {
-			cons_printf(portid,
-			            "%2dTW    0     0"
-			            " -                                          "
-			            " CLOSED\n",
-			            GET_TCP_TWCEPID(twcep));
-			}
-		else {
-			cons_printf(portid, "%2dTW    0     0 ", GET_TCP_TWCEPID(twcep));
-			len  = PUT_IPADDR(portid, &twcep->dstaddr.ipaddr, 0);
-			cons_putchar(portid, '.');
-			len += cons_putnumber(portid, twcep->dstaddr.portno, 10, radhex, 0, false, ' ');
-			for (len = 42 - len; len -- > 0; )
-				cons_putchar(portid, ' ');
-			if (twcep->fsm_state == TCP_FSM_TIME_WAIT)
-				cons_printf(portid, " %s(%d)\n", tcp_fsm_str[twcep->fsm_state],
-				                    twcep->timer_2msl / TCP_SLOW_HZ);
-			else
-				cons_printf(portid, " %s\n", tcp_fsm_str[twcep->fsm_state]);
-			}
-		}
-
-#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */
-
-#ifdef TCP_CFG_PASSIVE_OPEN
-
-	cons_printf(portid,
-	            "TCP REP Status\n"
-	            "ID  Local Address         CEP\n");
-	for (rep = tcp_rep; rep < &tcp_rep[tmax_tcp_repid]; rep ++) {
-		cons_printf(portid, "%2d%c ", GET_TCP_REPID(rep), DYNAMIC_TCP_REP(rep) ? 'D' : ' ');
+	for (repid = TMIN_TCP6_REPID; repid <= tmax_tcp6_repid; repid ++) {
+		rep = GET_TCP6_REP(repid);
+		cons_printf(portid, "%2d%c ", GET_TCP6_REPID(rep), DYNAMIC_TCP_REP(rep) ? 'D' : ' ');
 		if (VALID_TCP_REP(rep)) {
 			len  = PUT_IPADDR(portid, &rep->myaddr.ipaddr, 0);
@@ -439,5 +453,5 @@
 			cnt = 0;
 			for (cep = tcp_cep; cep < &tcp_cep[tmax_tcp_cepid]; cep ++) {
-				if (cep->rep == rep) {
+				if (TCP_IS_CEP_IPV6(cep) && cep->rep == rep) {
 					if (cnt > 0)
 						cons_printf(portid, ",%d", GET_TCP_CEPID(cep));
@@ -452,38 +466,51 @@
 		cons_putchar(portid, '\n');
 		}
-
-#endif	/* of #ifdef TCP_CFG_PASSIVE_OPEN */
-
-	SIG_NET_CONS_PRINTF();
-	FLUSH_SND_BUFF();
-	}
-
-#endif	/* of #if defined(SUPPORT_INET6) */
-
-#endif	/* of #ifdef SUPPORT_TCP */
-
-#ifdef SUPPORT_UDP
-
-/*
- *  udp_status -- UDP の状態の出力
- */
+	}
+
+#endif	/* of #if TNUM_TCP6_REPID > 0 */
+
+#if TNUM_TCP4_REPID > 0
 
 static void
-udp_status (ID portid, char *line)
-{
-	T_UDP_CEP*	cep;
+tcp4_rep_status (ID portid, char *line)
+{
+	T_TCP_CEP*	cep;
+	T_TCP4_REP*	rep;
+	ID		repid;
+	int_t		cnt;
 	uint_t		len;
 
-	WAI_NET_CONS_PRINTF();
 	cons_printf(portid,
-	            "UDP CEP Status\n"
-	            "ID  Local Address\n");
-
-	for (cep = udp_cep; cep < &udp_cep[tmax_udp_ccepid]; cep ++) {
-		cons_printf(portid, "%2d%c ", GET_UDP_CEPID(cep), DYNAMIC_UDP_CEP(cep) ? 'D' : ' ');
-		if (VALID_UDP_CEP(cep)) {
-			len  = PUT_IPADDR(portid, &cep->myaddr.ipaddr, 0);
-			cons_putchar(portid, '.');
-			len += cons_putnumber(portid, cep->myaddr.portno, 10, radhex, 0, false, ' ');
+	            "TCP4 REP Status\n"
+	            "ID  Local Address         CEP\n");
+	for (repid = TMIN_TCP4_REPID; repid <= tmax_tcp4_repid; repid ++) {
+		rep = GET_TCP4_REP(repid);
+		cons_printf(portid, "%2d%c ", GET_TCP4_REPID(rep), DYNAMIC_TCP_REP(rep) ? 'D' : ' ');
+		if (VALID_TCP_REP(rep)) {
+			len  = put_ipv4addr(portid, &rep->myaddr.ipaddr, 0);
+			cons_putchar(portid, ':');
+			len += cons_putnumber(portid, rep->myaddr.portno, 10, radhex, 0, false, ' ');
+			for (len = 21 - len; len -- > 0; )
+				cons_putchar(portid, ' ');
+			cnt = 0;
+			for (cep = tcp_cep; cep < &tcp_cep[tmax_tcp_cepid]; cep ++) {
+
+#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
+
+				if (TCP_IS_CEP_IPV4(cep) && cep->rep4 == rep) {
+
+#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
+
+				if (TCP_IS_CEP_IPV4(cep) && cep->rep == rep) {
+
+#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
+
+					if (cnt > 0)
+						cons_printf(portid, ",%d", GET_TCP_CEPID(cep));
+					else
+						cons_printf(portid, "%d", GET_TCP_CEPID(cep));
+					cnt ++;
+					}
+				}
 			}
 		else
@@ -491,4 +518,22 @@
 		cons_putchar(portid, '\n');
 		}
+	}
+
+#endif	/* of #if TNUM_TCP4_REPID > 0 */
+
+static void
+tcp_status (ID portid, char *line)
+{
+	WAI_NET_CONS_PRINTF();
+
+	tcp_cep_status(portid, line);
+
+#if TNUM_TCP6_REPID > 0
+	tcp6_rep_status(portid, line);
+#endif
+
+#if TNUM_TCP4_REPID > 0
+	tcp4_rep_status(portid, line);
+#endif
 
 	SIG_NET_CONS_PRINTF();
@@ -496,33 +541,92 @@
 	}
 
-#endif	/* of #ifdef SUPPORT_UDP */
-
-#ifdef SUPPORT_ETHER
-
-#if defined(SUPPORT_INET4)
+#endif	/* of #ifdef SUPPORT_TCP */
+
+#ifdef SUPPORT_UDP
 
 /*
- *  ifa_status -- ARP キャッシュ出力
- */
+ *  udp6_status -- UDP の状態の出力
+ */
+
+#if TNUM_UDP6_CEPID > 0
+
+extern const ID tmax_tcp_cepid;
 
 static void
-ifa_status (ID portid, char *line)
-{
-	const T_ARP_ENTRY	*cache;
-	int_t			ix;
-
+udp6_status (ID portid, char *line)
+{
+	T_UDP6_CEP*	cep;
+	ID		cepid;
+	uint_t		len;
+
+	cons_printf(portid,
+	            "UDP6 CEP Status\n"
+	            "ID  Local Address\n");
+
+	for (cepid = TMIN_UDP6_CEPID; cepid <= tmax_udp6_cepid; cepid ++) {
+		cep = GET_UDP6_CEP(cepid);
+		cons_printf(portid, "%2d%c ", GET_UDP6_CEPID(cep), DYNAMIC_UDP_CEP(cep) ? 'D' : ' ');
+		if (VALID_UDP_CEP(cep)) {
+			len  = put_ipv6addr(portid, &cep->myaddr.ipaddr, 0);
+			cons_putchar(portid, '.');
+			len += cons_putnumber(portid, cep->myaddr.portno, 10, radhex, 0, false, ' ');
+			}
+		else
+			cons_printf(portid, "INVALID");
+		cons_putchar(portid, '\n');
+		}
+
+	SIG_NET_CONS_PRINTF();
+	}
+
+#endif	/* of #if TNUM_UDP6_CEPID > 0 */
+
+/*
+ *  udp4_status -- UDP の状態の出力
+ */
+
+#if TNUM_UDP4_CEPID > 0
+
+static void
+udp4_status (ID portid, char *line)
+{
+	T_UDP4_CEP*	cep;
+	ID		cepid;
+	uint_t		len;
+
+	cons_printf(portid,
+	            "UDP4 CEP Status\n"
+	            "ID  Local Address\n");
+
+	for (cepid = TMIN_UDP4_CEPID; cepid <= tmax_udp4_cepid; cepid ++) {
+		cep = GET_UDP4_CEP(cepid);
+		cons_printf(portid, "%2d%c ", GET_UDP4_CEPID(cep), DYNAMIC_UDP_CEP(cep) ? 'D' : ' ');
+		if (VALID_UDP_CEP(cep)) {
+			len  = put_ipv4addr(portid, &cep->myaddr.ipaddr, 0);
+			cons_putchar(portid, '.');
+			len += cons_putnumber(portid, cep->myaddr.portno, 10, radhex, 0, false, ' ');
+			}
+		else
+			cons_printf(portid, "INVALID");
+		cons_putchar(portid, '\n');
+		}
+
+	SIG_NET_CONS_PRINTF();
+	}
+
+#endif	/* of #if TNUM_UDP4_CEPID > 0 */
+
+static void
+udp_status (ID portid, char *line)
+{
 	WAI_NET_CONS_PRINTF();
-	cons_printf(portid,
-	            "ARP Cache\n"
-	            "IX Expire IP Address      MAC Address\n");
-
-	/* expire の単位は [ms]。*/
-	cache = arp_get_cache();
-	for (ix = 0; ix < NUM_ARP_ENTRY; ix ++) {
-		if (cache[ix].expire != 0)
-			cons_printf(portid, "%2d %6d %15I %M\n",
-			                    ix, cache[ix].expire / NET_TIMER_HZ,
-			                    &cache[ix].ip_addr, cache[ix].mac_addr);
-		}
+
+#if TNUM_UDP6_CEPID > 0
+	udp6_status(portid, line);
+#endif
+
+#if TNUM_UDP4_CEPID > 0
+	udp4_status(portid, line);
+#endif
 
 	SIG_NET_CONS_PRINTF();
@@ -530,10 +634,12 @@
 	}
 
-#endif	/* of #if defined(SUPPORT_INET4) */
+#endif	/* of #ifdef SUPPORT_UDP */
+
+#ifdef SUPPORT_ETHER
 
 #if defined(SUPPORT_INET6)
 
 /*
- * ifa_status -- 近隣キャッシュ状態の出力
+ * ifa6_status -- 近隣キャッシュ状態の出力
  */
 
@@ -549,5 +655,5 @@
 
 static void
-ifa_status (ID portid, char *line)
+ifa6_status (ID portid, char *line)
 {
 	const T_LLINFO_ND6	*cache;
@@ -565,9 +671,9 @@
 	for (ix = 0; ix < NUM_ND6_CACHE_ENTRY; ix ++) {
 		if (cache[ix].state != ND6_LLINFO_FREE) {
-			cons_printf(portid, "%2d %6d %10s %M %I\n",
+			cons_printf(portid, "%2d %6ld %10s %M %lI\n",
 			            ix, 
 			            cache[ix].state == ND6_LLINFO_STALE ||
-			            (uint32_t)(cache[ix].expire - now) <= 0
-			                ? 0 : (cache[ix].expire - now) / SYSTIM_HZ,
+			            (uint32_t)((int32_t)(cache[ix].expire - now) <= 0
+			                 ? 0 : (int32_t)(cache[ix].expire - now) / SYSTIM_HZ),
 			            nd_state_str[cache[ix].state],
 			            &cache[ix].ifaddr,
@@ -581,4 +687,36 @@
 
 #endif	/* of #if defined(SUPPORT_INET6) */
+
+#if defined(SUPPORT_INET4)
+
+/*
+ *  ifa4_status -- ARP キャッシュ出力
+ */
+
+static void
+ifa4_status (ID portid, char *line)
+{
+	const T_ARP_ENTRY	*cache;
+	int_t			ix;
+
+	WAI_NET_CONS_PRINTF();
+	cons_printf(portid,
+	            "ARP Cache\n"
+	            "IX Expire MAC Address       IP Address\n");
+
+	/* expire の単位は [ms]。*/
+	cache = arp_get_cache();
+	for (ix = 0; ix < NUM_ARP_ENTRY; ix ++) {
+		if (cache[ix].expire != 0)
+			cons_printf(portid, "%2d %6d %M %hI\n",
+			                    ix, cache[ix].expire / NET_TIMER_HZ,
+			                    cache[ix].mac_addr, &cache[ix].ip_addr);
+		}
+
+	SIG_NET_CONS_PRINTF();
+	FLUSH_SND_BUFF();
+	}
+
+#endif	/* of #if defined(SUPPORT_INET4) */
 
 #endif	/* of #ifdef SUPPORT_ETHER */
@@ -673,4 +811,46 @@
 
 #endif	/* of #ifdef SUPPORT_ETHER */
+
+#if defined(SUPPORT_INET6)
+
+	cons_printf(portid, "\nIPv6\n");
+	cons_printf(portid, "\t受信オクテット数\t%lu\n",		net_count_ip6[NC_IP6_IN_OCTETS]);
+	cons_printf(portid, "\t受信データグラム数\t%lu\n",		net_count_ip6[NC_IP6_IN_PACKETS]);
+	cons_printf(portid, "\t受信エラーデータグラム数\t%lu\n",	net_count_ip6[NC_IP6_IN_ERR_PACKETS]);
+	cons_printf(portid, "\t長さエラー数\t%lu\n",			net_count_ip6[NC_IP6_IN_ERR_SHORT]);
+	cons_printf(portid, "\tバージョンエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_VER]);
+	cons_printf(portid, "\tアドレスエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_ADDR]);
+	cons_printf(portid, "\tプロトコルエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_PROTO]);
+	cons_printf(portid, "\t分割受信数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_IN]);
+	cons_printf(portid, "\t分割受信フラグメント数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_FRAGS]);
+	cons_printf(portid, "\t分割受信再構成成功数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_OK]);
+	cons_printf(portid, "\t分割受信破棄数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_IN_DROP]);
+	cons_printf(portid, "\t分割受信バッファり当て失敗数\t%lu\n",	net_count_ip6[NC_IP6_FRAG_IN_NO_BUF]);
+	cons_printf(portid, "\t分割受信タイムアウト数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_TMOUT]);
+	cons_printf(portid, "\t送信オクテット数\t%lu\n",		net_count_ip6[NC_IP6_OUT_OCTETS]);
+	cons_printf(portid, "\t送信データグラム数\t%lu\n",		net_count_ip6[NC_IP6_OUT_PACKETS]);
+	cons_printf(portid, "\t送信エラーデータグラム数\t%lu\n",	net_count_ip6[NC_IP6_OUT_ERR_PACKETS]);
+	cons_printf(portid, "\t分割送信数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_OUT]);
+	cons_printf(portid, "\t分割送信フラグメント数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_OUT_FRAGS]);
+
+	cons_printf(portid, "\nICMPv6\n");
+	cons_printf(portid, "\t受信オクテット数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_OCTETS]);
+	cons_printf(portid, "\t受信パケット数\t%lu\n",			net_count_icmp6[NC_ICMP6_IN_PACKETS]);
+	cons_printf(portid, "\t受信エラーパケット数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_PACKETS]);
+	cons_printf(portid, "\t受信チックサムエラー数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_CKSUM]);
+	cons_printf(portid, "\t送信オクテット数\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_OCTETS]);
+	cons_printf(portid, "\t送信パケット数\t%lu\n",			net_count_icmp6[NC_ICMP6_OUT_PACKETS]);
+	cons_printf(portid, "\t送信エラーパケット数\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_ERR_PACKETS]);
+
+	cons_printf(portid, "\n近隣探索\n");
+	cons_printf(portid, "\tルータ通知受信数\t%lu\n",		net_count_nd6[NC_ND6_RA_IN_PACKETS]);
+	cons_printf(portid, "\tルータ要請送信数\t%lu\n",		net_count_nd6[NC_ND6_RS_OUT_PACKETS]);
+	cons_printf(portid, "\t近隣通知受信数\t%lu\n",			net_count_nd6[NC_ND6_NA_IN_PACKETS]);
+	cons_printf(portid, "\t近隣通知送信数\t%lu\n",			net_count_nd6[NC_ND6_NA_OUT_PACKETS]);
+	cons_printf(portid, "\t近隣要請受信数\t%lu\n",			net_count_nd6[NC_ND6_NS_IN_PACKETS]);
+	cons_printf(portid, "\t近隣要請送信数\t%lu\n",			net_count_nd6[NC_ND6_NS_OUT_PACKETS]);
+	cons_printf(portid, "\t重複アドレス検出送信数\t%lu\n",		net_count_nd6[NC_ND6_DAD_OUT_PACKETS]);
+
+#else	/* of #if defined(SUPPORT_INET6) */
 
 #if defined(SUPPORT_INET4)
@@ -707,44 +887,4 @@
 
 #endif	/* of #if defined(SUPPORT_INET4) */
-
-#if defined(SUPPORT_INET6)
-
-	cons_printf(portid, "\nIPv6\n");
-	cons_printf(portid, "\t受信オクテット数\t%lu\n",		net_count_ip6[NC_IP6_IN_OCTETS]);
-	cons_printf(portid, "\t受信データグラム数\t%lu\n",		net_count_ip6[NC_IP6_IN_PACKETS]);
-	cons_printf(portid, "\t受信エラーデータグラム数\t%lu\n",	net_count_ip6[NC_IP6_IN_ERR_PACKETS]);
-	cons_printf(portid, "\t長さエラー数\t%lu\n",			net_count_ip6[NC_IP6_IN_ERR_SHORT]);
-	cons_printf(portid, "\tバージョンエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_VER]);
-	cons_printf(portid, "\tアドレスエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_ADDR]);
-	cons_printf(portid, "\tプロトコルエラー数\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_PROTO]);
-	cons_printf(portid, "\t分割受信数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_IN]);
-	cons_printf(portid, "\t分割受信フラグメント数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_FRAGS]);
-	cons_printf(portid, "\t分割受信再構成成功数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_OK]);
-	cons_printf(portid, "\t分割受信破棄数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_IN_DROP]);
-	cons_printf(portid, "\t分割受信バッファり当て失敗数\t%lu\n",	net_count_ip6[NC_IP6_FRAG_IN_NO_BUF]);
-	cons_printf(portid, "\t分割受信タイムアウト数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_IN_TMOUT]);
-	cons_printf(portid, "\t送信オクテット数\t%lu\n",		net_count_ip6[NC_IP6_OUT_OCTETS]);
-	cons_printf(portid, "\t送信データグラム数\t%lu\n",		net_count_ip6[NC_IP6_OUT_PACKETS]);
-	cons_printf(portid, "\t送信エラーデータグラム数\t%lu\n",	net_count_ip6[NC_IP6_OUT_ERR_PACKETS]);
-	cons_printf(portid, "\t分割送信数\t%lu\n",			net_count_ip6[NC_IP6_FRAG_OUT]);
-	cons_printf(portid, "\t分割送信フラグメント数\t%lu\n",		net_count_ip6[NC_IP6_FRAG_OUT_FRAGS]);
-
-	cons_printf(portid, "\nICMPv6\n");
-	cons_printf(portid, "\t受信オクテット数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_OCTETS]);
-	cons_printf(portid, "\t受信パケット数\t%lu\n",			net_count_icmp6[NC_ICMP6_IN_PACKETS]);
-	cons_printf(portid, "\t受信エラーパケット数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_PACKETS]);
-	cons_printf(portid, "\t受信チックサムエラー数\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_CKSUM]);
-	cons_printf(portid, "\t送信オクテット数\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_OCTETS]);
-	cons_printf(portid, "\t送信パケット数\t%lu\n",			net_count_icmp6[NC_ICMP6_OUT_PACKETS]);
-	cons_printf(portid, "\t送信エラーパケット数\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_ERR_PACKETS]);
-
-	cons_printf(portid, "\n近隣探索\n");
-	cons_printf(portid, "\tルータ通知受信数\t%lu\n",		net_count_nd6[NC_ND6_RA_IN_PACKETS]);
-	cons_printf(portid, "\tルータ要請送信数\t%lu\n",		net_count_nd6[NC_ND6_RS_OUT_PACKETS]);
-	cons_printf(portid, "\t近隣通知受信数\t%lu\n",			net_count_nd6[NC_ND6_NA_IN_PACKETS]);
-	cons_printf(portid, "\t近隣通知送信数\t%lu\n",			net_count_nd6[NC_ND6_NA_OUT_PACKETS]);
-	cons_printf(portid, "\t近隣要請受信数\t%lu\n",			net_count_nd6[NC_ND6_NS_IN_PACKETS]);
-	cons_printf(portid, "\t近隣要請送信数\t%lu\n",			net_count_nd6[NC_ND6_NS_OUT_PACKETS]);
-	cons_printf(portid, "\t重複アドレス検出送信数\t%lu\n",		net_count_nd6[NC_ND6_DAD_OUT_PACKETS]);
 
 #endif	/* of #if defined(SUPPORT_INET6) */
@@ -787,9 +927,10 @@
 
 	tbl = nbuf_get_tbl();
-	cons_printf(portid, "\nネットワークバッファ\n\tサイズ\t用意数\t割当要求数\t割当数\t割当てエラー数\n");
+	cons_printf(portid, "\nネットワークバッファ\n\tサイズ\t用意数\t使用中数\t割当要求数\t割当数\t割当てエラー数\n");
 	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
-		cons_printf(portid, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
+		cons_printf(portid, "\t%lu\t%lu\t%lu\t%lu\t%lu\t%lu\n",
 		                    tbl[ix].size,
 		                    tbl[ix].prepares,
+		                    tbl[ix].busies,
 		                    tbl[ix].requests,
 		                    tbl[ix].allocs,
@@ -833,5 +974,5 @@
 	for (ix = nbuf_get_tbl_size(); ix -- > 0; )
 		cons_printf(portid, "\t%d", tbl[ix].size);
-	cons_printf(portid, "\n");
+	cons_putchar(portid, '\n');
 
 	queue = ip_get_frag_queue();
@@ -846,5 +987,5 @@
 				cons_printf(portid, "\t%d", count);
 				}
-			cons_printf(portid, "\n");
+			cons_putchar(portid, '\n');
 			}
 		}
@@ -874,5 +1015,5 @@
 	for (ix = nbuf_get_tbl_size(); ix -- > 0; )
 		cons_printf(portid, "\t%d", tbl[ix].size);
-	cons_printf(portid, "\n");
+	cons_putchar(portid, '\n');
 
 	queue = ip6_get_frag_queue();
@@ -887,5 +1028,5 @@
 				cons_printf(portid, "\t%d", count);
 				}
-			cons_printf(portid, "\n");
+			cons_putchar(portid, '\n');
 			}
 		}
@@ -918,5 +1059,4 @@
 
 #ifdef TCP_CFG_SWBUF_CSAVE
-	T_IP_HDR*		iph;
 	T_TCP_HDR*		tcph;
 #endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */
@@ -925,14 +1065,15 @@
 	WAI_NET_CONS_PRINTF();
 	get_tim(&now);
-	cons_printf(portid, "ネットワークバッファ情報\t経過時間[ms]\t%lu\n", now);
+	cons_printf(portid, "ネットワークバッファ情報\t経過時間[ms]\t%u\n", now);
 
 #if NET_COUNT_ENABLE
 
-	cons_printf(portid, "\nネットワークバッファ\n\tサイズ\t用意数\t割当要求数\t割当数\t割当てエラー数\n");
+	cons_printf(portid, "\nネットワークバッファ\n\tサイズ\t用意数\t使用中数\t割当要求数\t割当数\t割当てエラー数\n");
 	tbl = nbuf_get_tbl();
 	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
-		cons_printf(portid, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
+		cons_printf(portid, "\t%u\t%u\t%u\t%u\t%u\t%u\n",
 		                    tbl[ix].size,
 		                    tbl[ix].prepares,
+		                    tbl[ix].busies,
 		                    tbl[ix].requests,
 		                    tbl[ix].allocs,
@@ -949,6 +1090,6 @@
 		cons_printf(portid, "%2d", GET_TCP_CEPID(cep));
 		for (nbuf = cep->reassq; nbuf != NULL; nbuf = tqhdr->next) {
-			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_IP_Q_HDR(nbuf)->thoff);
-			cons_printf(portid, "[a:%6d-%6d] ",
+			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_HDR_OFFSET(nbuf));
+			cons_printf(portid, "[a:%6lu-%6lu] ",
 			            ntohl(tqhdr->seq) - cep->irs + tqhdr->soff,
 			            ntohl(tqhdr->seq) - cep->irs + tqhdr->soff + tqhdr->slen);
@@ -957,6 +1098,6 @@
 #ifdef TCP_CFG_RWBUF_CSAVE
 		for (nbuf = cep->rwbufq; nbuf != NULL; nbuf = tqhdr->next) {
-			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_IP_Q_HDR(nbuf)->thoff);
-			cons_printf(portid, "[r:%6d-%6d] ",
+			tqhdr = GET_TCP_Q_HDR(nbuf, GET_TCP_HDR_OFFSET(nbuf));
+			cons_printf(portid, "[r:%6lu-%6lu] ",
 			            ntohl(tqhdr->seq) - cep->irs + tqhdr->soff,
 			            ntohl(tqhdr->seq) - cep->irs + tqhdr->soff + tqhdr->slen);
@@ -966,14 +1107,21 @@
 #ifdef TCP_CFG_SWBUF_CSAVE
 		if (cep->swbufq != NULL) {
-			iph  = GET_IP_HDR(cep->swbufq);
 			tcph = GET_TCP_HDR(cep->swbufq, GET_TCP_HDR_OFFSET(cep->swbufq));
-			cons_printf(portid, "[s:%6d-%6d] ",
+#if 0
+			cons_printf(portid, "[s:%6lu-%6lu] ",
 			            ntohl(tcph->seq) - cep->iss,
-			            ntohl(tcph->seq) - cep->iss + (GET_IP_SDU_SIZE(iph) - 
-			                                           GET_TCP_HDR_SIZE2(cep->swbufq, GET_TCP_HDR_OFFSET(cep->swbufq))));
+			            ntohl(tcph->seq) - cep->iss + (GET_IP_SDU_SIZE(cep->swbufq) - 
+			                                           GET_TCP_HDR_SIZE(cep->swbufq, GET_TCP_HDR_OFFSET(cep->swbufq))));
+#else
+			cons_printf(portid, "[s:%6lu-%6lu,%08x,%08x] ",
+			            ntohl(tcph->seq) - cep->iss,
+			            ntohl(tcph->seq) - cep->iss + (GET_IP_SDU_SIZE(cep->swbufq) - 
+			                                           GET_TCP_HDR_SIZE(cep->swbufq, GET_TCP_HDR_OFFSET(cep->swbufq))),
+			            ntohl(tcph->seq), cep->iss);
+#endif
 			}
 #endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */
 
-		cons_printf(portid, "\n");
+		cons_putchar(portid, '\n');
 		}
 
